# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from mesh_msgs/MeshMaterialsStamped.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import mesh_msgs.msg
import std_msgs.msg

class MeshMaterialsStamped(genpy.Message):
  _md5sum = "80683ad6336327fea277cb1ed5f58927"
  _type = "mesh_msgs/MeshMaterialsStamped"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# Mesh Attribute Message
std_msgs/Header header
string uuid
mesh_msgs/MeshMaterials mesh_materials

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: mesh_msgs/MeshMaterials
# Mesh Attribute Message
mesh_msgs/MeshFaceCluster[] clusters
mesh_msgs/MeshMaterial[] materials
uint32[] cluster_materials
mesh_msgs/MeshVertexTexCoords[] vertex_tex_coords

================================================================================
MSG: mesh_msgs/MeshFaceCluster
#Cluster
uint32[] face_indices
#optional
string label

================================================================================
MSG: mesh_msgs/MeshMaterial
uint32 texture_index
std_msgs/ColorRGBA color
bool has_texture

================================================================================
MSG: std_msgs/ColorRGBA
float32 r
float32 g
float32 b
float32 a

================================================================================
MSG: mesh_msgs/MeshVertexTexCoords
# Mesh Attribute Type
float32 u
float32 v
"""
  __slots__ = ['header','uuid','mesh_materials']
  _slot_types = ['std_msgs/Header','string','mesh_msgs/MeshMaterials']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,uuid,mesh_materials

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MeshMaterialsStamped, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.uuid is None:
        self.uuid = ''
      if self.mesh_materials is None:
        self.mesh_materials = mesh_msgs.msg.MeshMaterials()
    else:
      self.header = std_msgs.msg.Header()
      self.uuid = ''
      self.mesh_materials = mesh_msgs.msg.MeshMaterials()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.uuid
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.mesh_materials.clusters)
      buff.write(_struct_I.pack(length))
      for val1 in self.mesh_materials.clusters:
        length = len(val1.face_indices)
        buff.write(_struct_I.pack(length))
        pattern = '<%sI'%length
        buff.write(struct.Struct(pattern).pack(*val1.face_indices))
        _x = val1.label
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.mesh_materials.materials)
      buff.write(_struct_I.pack(length))
      for val1 in self.mesh_materials.materials:
        _x = val1.texture_index
        buff.write(_get_struct_I().pack(_x))
        _v1 = val1.color
        _x = _v1
        buff.write(_get_struct_4f().pack(_x.r, _x.g, _x.b, _x.a))
        _x = val1.has_texture
        buff.write(_get_struct_B().pack(_x))
      length = len(self.mesh_materials.cluster_materials)
      buff.write(_struct_I.pack(length))
      pattern = '<%sI'%length
      buff.write(struct.Struct(pattern).pack(*self.mesh_materials.cluster_materials))
      length = len(self.mesh_materials.vertex_tex_coords)
      buff.write(_struct_I.pack(length))
      for val1 in self.mesh_materials.vertex_tex_coords:
        _x = val1
        buff.write(_get_struct_2f().pack(_x.u, _x.v))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.mesh_materials is None:
        self.mesh_materials = mesh_msgs.msg.MeshMaterials()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.uuid = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.uuid = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.mesh_materials.clusters = []
      for i in range(0, length):
        val1 = mesh_msgs.msg.MeshFaceCluster()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sI'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.face_indices = s.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.label = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.label = str[start:end]
        self.mesh_materials.clusters.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.mesh_materials.materials = []
      for i in range(0, length):
        val1 = mesh_msgs.msg.MeshMaterial()
        start = end
        end += 4
        (val1.texture_index,) = _get_struct_I().unpack(str[start:end])
        _v2 = val1.color
        _x = _v2
        start = end
        end += 16
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4f().unpack(str[start:end])
        start = end
        end += 1
        (val1.has_texture,) = _get_struct_B().unpack(str[start:end])
        val1.has_texture = bool(val1.has_texture)
        self.mesh_materials.materials.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sI'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.mesh_materials.cluster_materials = s.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.mesh_materials.vertex_tex_coords = []
      for i in range(0, length):
        val1 = mesh_msgs.msg.MeshVertexTexCoords()
        _x = val1
        start = end
        end += 8
        (_x.u, _x.v,) = _get_struct_2f().unpack(str[start:end])
        self.mesh_materials.vertex_tex_coords.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.uuid
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.mesh_materials.clusters)
      buff.write(_struct_I.pack(length))
      for val1 in self.mesh_materials.clusters:
        length = len(val1.face_indices)
        buff.write(_struct_I.pack(length))
        pattern = '<%sI'%length
        buff.write(val1.face_indices.tostring())
        _x = val1.label
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.mesh_materials.materials)
      buff.write(_struct_I.pack(length))
      for val1 in self.mesh_materials.materials:
        _x = val1.texture_index
        buff.write(_get_struct_I().pack(_x))
        _v3 = val1.color
        _x = _v3
        buff.write(_get_struct_4f().pack(_x.r, _x.g, _x.b, _x.a))
        _x = val1.has_texture
        buff.write(_get_struct_B().pack(_x))
      length = len(self.mesh_materials.cluster_materials)
      buff.write(_struct_I.pack(length))
      pattern = '<%sI'%length
      buff.write(self.mesh_materials.cluster_materials.tostring())
      length = len(self.mesh_materials.vertex_tex_coords)
      buff.write(_struct_I.pack(length))
      for val1 in self.mesh_materials.vertex_tex_coords:
        _x = val1
        buff.write(_get_struct_2f().pack(_x.u, _x.v))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.mesh_materials is None:
        self.mesh_materials = mesh_msgs.msg.MeshMaterials()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.uuid = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.uuid = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.mesh_materials.clusters = []
      for i in range(0, length):
        val1 = mesh_msgs.msg.MeshFaceCluster()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sI'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.face_indices = numpy.frombuffer(str[start:end], dtype=numpy.uint32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.label = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.label = str[start:end]
        self.mesh_materials.clusters.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.mesh_materials.materials = []
      for i in range(0, length):
        val1 = mesh_msgs.msg.MeshMaterial()
        start = end
        end += 4
        (val1.texture_index,) = _get_struct_I().unpack(str[start:end])
        _v4 = val1.color
        _x = _v4
        start = end
        end += 16
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4f().unpack(str[start:end])
        start = end
        end += 1
        (val1.has_texture,) = _get_struct_B().unpack(str[start:end])
        val1.has_texture = bool(val1.has_texture)
        self.mesh_materials.materials.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sI'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.mesh_materials.cluster_materials = numpy.frombuffer(str[start:end], dtype=numpy.uint32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.mesh_materials.vertex_tex_coords = []
      for i in range(0, length):
        val1 = mesh_msgs.msg.MeshVertexTexCoords()
        _x = val1
        start = end
        end += 8
        (_x.u, _x.v,) = _get_struct_2f().unpack(str[start:end])
        self.mesh_materials.vertex_tex_coords.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2f = None
def _get_struct_2f():
    global _struct_2f
    if _struct_2f is None:
        _struct_2f = struct.Struct("<2f")
    return _struct_2f
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_4f = None
def _get_struct_4f():
    global _struct_4f
    if _struct_4f is None:
        _struct_4f = struct.Struct("<4f")
    return _struct_4f
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
