// Auto-generated. Do not edit!

// (in-package mesh_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let MeshFaceCluster = require('./MeshFaceCluster.js');
let MeshMaterial = require('./MeshMaterial.js');
let MeshVertexTexCoords = require('./MeshVertexTexCoords.js');

//-----------------------------------------------------------

class MeshMaterials {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.clusters = null;
      this.materials = null;
      this.cluster_materials = null;
      this.vertex_tex_coords = null;
    }
    else {
      if (initObj.hasOwnProperty('clusters')) {
        this.clusters = initObj.clusters
      }
      else {
        this.clusters = [];
      }
      if (initObj.hasOwnProperty('materials')) {
        this.materials = initObj.materials
      }
      else {
        this.materials = [];
      }
      if (initObj.hasOwnProperty('cluster_materials')) {
        this.cluster_materials = initObj.cluster_materials
      }
      else {
        this.cluster_materials = [];
      }
      if (initObj.hasOwnProperty('vertex_tex_coords')) {
        this.vertex_tex_coords = initObj.vertex_tex_coords
      }
      else {
        this.vertex_tex_coords = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type MeshMaterials
    // Serialize message field [clusters]
    // Serialize the length for message field [clusters]
    bufferOffset = _serializer.uint32(obj.clusters.length, buffer, bufferOffset);
    obj.clusters.forEach((val) => {
      bufferOffset = MeshFaceCluster.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [materials]
    // Serialize the length for message field [materials]
    bufferOffset = _serializer.uint32(obj.materials.length, buffer, bufferOffset);
    obj.materials.forEach((val) => {
      bufferOffset = MeshMaterial.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [cluster_materials]
    bufferOffset = _arraySerializer.uint32(obj.cluster_materials, buffer, bufferOffset, null);
    // Serialize message field [vertex_tex_coords]
    // Serialize the length for message field [vertex_tex_coords]
    bufferOffset = _serializer.uint32(obj.vertex_tex_coords.length, buffer, bufferOffset);
    obj.vertex_tex_coords.forEach((val) => {
      bufferOffset = MeshVertexTexCoords.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type MeshMaterials
    let len;
    let data = new MeshMaterials(null);
    // Deserialize message field [clusters]
    // Deserialize array length for message field [clusters]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.clusters = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.clusters[i] = MeshFaceCluster.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [materials]
    // Deserialize array length for message field [materials]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.materials = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.materials[i] = MeshMaterial.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [cluster_materials]
    data.cluster_materials = _arrayDeserializer.uint32(buffer, bufferOffset, null)
    // Deserialize message field [vertex_tex_coords]
    // Deserialize array length for message field [vertex_tex_coords]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.vertex_tex_coords = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.vertex_tex_coords[i] = MeshVertexTexCoords.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    object.clusters.forEach((val) => {
      length += MeshFaceCluster.getMessageSize(val);
    });
    length += 21 * object.materials.length;
    length += 4 * object.cluster_materials.length;
    length += 8 * object.vertex_tex_coords.length;
    return length + 16;
  }

  static datatype() {
    // Returns string type for a message object
    return 'mesh_msgs/MeshMaterials';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'e151c9a065aae90d545559129a79a70a';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Mesh Attribute Message
    mesh_msgs/MeshFaceCluster[] clusters
    mesh_msgs/MeshMaterial[] materials
    uint32[] cluster_materials
    mesh_msgs/MeshVertexTexCoords[] vertex_tex_coords
    
    ================================================================================
    MSG: mesh_msgs/MeshFaceCluster
    #Cluster
    uint32[] face_indices
    #optional
    string label
    
    ================================================================================
    MSG: mesh_msgs/MeshMaterial
    uint32 texture_index
    std_msgs/ColorRGBA color
    bool has_texture
    
    ================================================================================
    MSG: std_msgs/ColorRGBA
    float32 r
    float32 g
    float32 b
    float32 a
    
    ================================================================================
    MSG: mesh_msgs/MeshVertexTexCoords
    # Mesh Attribute Type
    float32 u
    float32 v
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new MeshMaterials(null);
    if (msg.clusters !== undefined) {
      resolved.clusters = new Array(msg.clusters.length);
      for (let i = 0; i < resolved.clusters.length; ++i) {
        resolved.clusters[i] = MeshFaceCluster.Resolve(msg.clusters[i]);
      }
    }
    else {
      resolved.clusters = []
    }

    if (msg.materials !== undefined) {
      resolved.materials = new Array(msg.materials.length);
      for (let i = 0; i < resolved.materials.length; ++i) {
        resolved.materials[i] = MeshMaterial.Resolve(msg.materials[i]);
      }
    }
    else {
      resolved.materials = []
    }

    if (msg.cluster_materials !== undefined) {
      resolved.cluster_materials = msg.cluster_materials;
    }
    else {
      resolved.cluster_materials = []
    }

    if (msg.vertex_tex_coords !== undefined) {
      resolved.vertex_tex_coords = new Array(msg.vertex_tex_coords.length);
      for (let i = 0; i < resolved.vertex_tex_coords.length; ++i) {
        resolved.vertex_tex_coords[i] = MeshVertexTexCoords.Resolve(msg.vertex_tex_coords[i]);
      }
    }
    else {
      resolved.vertex_tex_coords = []
    }

    return resolved;
    }
};

module.exports = MeshMaterials;
